﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;

namespace SampleGroupByRecords
{
    /// <summary>
    /// Interaction logic for Page1.xaml
    /// </summary>
    public partial class Page1 : Page
    {
        private bool isAdditionalRecordsAdded = true;

        public Page1()
        {
            InitializeComponent();

            if (!DesignerProperties.GetIsInDesignMode(this))
            {
                FieldLayout fieldLayout = new FieldLayout();
                this.grid.FieldLayouts.Add(fieldLayout);

                Field field = new Field();
                field.Name = "Name";
                field.Label = "Name";
                this.grid.FieldLayouts[0].Fields.Add(field);

                field = new Field();
                field.Name = "Age";
                field.Label = "Age";
                this.grid.FieldLayouts[0].Fields.Add(field);

                field = new Field();
                field.Name = "Department";
                field.Label = "Department";
                this.grid.FieldLayouts[0].Fields.Add(field);

                field = new Field();
                field.Name = "Subject";
                field.Label = "Subject";
                this.grid.FieldLayouts[0].Fields.Add(field);

                this.grid.DataSource = this.GetActualDataSource();
            }
        }

        private ObservableCollection<Student> GetActualDataSource()
        {
            ObservableCollection<Student> students = new ObservableCollection<Student>();

            Student st = new Student();
            st.Name = "Archana";
            st.Age = 17;
            st.Department = "Computer Science";
            st.Subject = "Computer";
            students.Add(st);

            st = new Student();
            st.Name = "Paul";
            st.Age = 16;
            st.Department = "Computer Science";
            st.Subject = "Java Language";
            students.Add(st);

            st = new Student();
            st.Name = "Java Language";
            st.Age = 17;
            st.Department = "Computer Science";
            st.Subject = "C Language";
            students.Add(st);

            st = new Student();
            st.Name = "David";
            st.Age = 17;
            st.Department = "Computer Science";
            st.Subject = "C Language";
            students.Add(st);

            st = new Student();
            st.Name = "Norwood";
            st.Age = 17;
            st.Department = "Computer Science";
            st.Subject = "C Language";
            students.Add(st);

            st = new Student();
            st.Name = "Steve";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Rosam";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Paulo DaCosta";
            st.Age = 16;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Evan	York";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Paul	Simmonds";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Robert Potts";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "Andy	Scott-Ham";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "David Flinders";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "Gary Clark";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "David Loveday";
            st.Age = 18;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "Alastair	Curry";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Trignometry";
            students.Add(st);

            st = new Student();
            st.Name = "Suchi Prabhakar";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Alzebra";
            students.Add(st);

            st = new Student();
            st.Name = "Stephen Walrond";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Alzebra";
            students.Add(st);

            st = new Student();
            st.Name = "John	Morton";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Trignometry";
            students.Add(st);

            st = new Student();
            st.Name = "Darren Cook";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Alzebra";
            students.Add(st);
            students.Add(st);

            return students;

        }

        private ObservableCollection<Student> GetAdditionalDataSource()
        {
            ObservableCollection<Student> students = this.GetActualDataSource();

            Student st = new Student();
            st.Name = "Aravind";
            st.Age = 17;
            st.Department = "Computer Science";
            st.Subject = "Computer";
            students.Add(st);

            st = new Student();
            st.Name = "Adithya";
            st.Age = 16;
            st.Department = "Computer Science";
            st.Subject = "Java Language";
            students.Add(st);

            st = new Student();
            st.Name = "Arun";
            st.Age = 17;
            st.Department = "Computer Science";
            st.Subject = "C Language";
            students.Add(st);

            st = new Student();
            st.Name = "Bhavani";
            st.Age = 17;
            st.Department = "Computer Science";
            st.Subject = "C Language";
            students.Add(st);

            st = new Student();
            st.Name = "Bala";
            st.Age = 17;
            st.Department = "Computer Science";
            st.Subject = "C Language";
            students.Add(st);

            st = new Student();
            st.Name = "Murugan";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Ramesh";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Suresh";
            st.Age = 16;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Ramya";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Ramani";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Chemistry";
            students.Add(st);

            st = new Student();
            st.Name = "Ravi";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "Ram";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "Jagadeesan";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "Guru";
            st.Age = 17;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "Sridhar";
            st.Age = 18;
            st.Department = "Science";
            st.Subject = "Physics";
            students.Add(st);

            st = new Student();
            st.Name = "Karthik";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Trignometry";
            students.Add(st);

            st = new Student();
            st.Name = "Mohan";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Alzebra";
            students.Add(st);

            st = new Student();
            st.Name = "Kalavathy";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Alzebra";
            students.Add(st);

            st = new Student();
            st.Name = "Ramya";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Trignometry";
            students.Add(st);

            st = new Student();
            st.Name = "Ramani";
            st.Age = 17;
            st.Department = "Mathematics";
            st.Subject = "Alzebra";
            students.Add(st);

            return students;

        }

        private void btnrefresh_Click(object sender, RoutedEventArgs e)
        {
            this.grid.DataSource = null;

            if (!this.isAdditionalRecordsAdded)
            {
                this.grid.DataSource = this.GetActualDataSource();
                this.isAdditionalRecordsAdded = true;
            }
            else
            {
                this.grid.DataSource = this.GetAdditionalDataSource();
                this.isAdditionalRecordsAdded = false;
            }
        }
    }

    public class Student
    {
        public Student()
        {

        }

        public string Name
        {
            get;
            set;
        }

        public int Age
        {
            get;
            set;
        }

        public string Department
        {
            get;
            set;
        }

        public string Subject
        {
            get;
            set;
        }
    }

}
